diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/mac-stats-calculator.cc ns-3.36/src/lte/helper/mac-stats-calculator.cc
--- ns-3.35/src/lte/helper/mac-stats-calculator.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/mac-stats-calculator.cc	2022-04-30 18:23:57.922733800 -0700
@@ -42,6 +42,15 @@
 MacStatsCalculator::~MacStatsCalculator ()
 {
   NS_LOG_FUNCTION (this);
+  if (m_dlOutFile.is_open())
+    {
+      m_dlOutFile.close();
+    }
+
+  if (m_ulOutFile.is_open())
+    {
+      m_ulOutFile.close();
+    }
 }
 
 TypeId
@@ -96,41 +105,30 @@
                    dlSchedulingCallbackInfo.rnti << (uint32_t) dlSchedulingCallbackInfo.mcsTb1 << dlSchedulingCallbackInfo.sizeTb1 << (uint32_t) dlSchedulingCallbackInfo.mcsTb2 << dlSchedulingCallbackInfo.sizeTb2);
   NS_LOG_INFO ("Write DL Mac Stats in " << GetDlOutputFilename ().c_str ());
 
-  std::ofstream outFile;
   if ( m_dlFirstWrite == true )
     {
-      outFile.open (GetDlOutputFilename ().c_str ());
-      if (!outFile.is_open ())
+      m_dlOutFile.open (GetDlOutputFilename ().c_str ());
+      if (!m_dlOutFile.is_open ())
         {
           NS_LOG_ERROR ("Can't open file " << GetDlOutputFilename ().c_str ());
           return;
         }
       m_dlFirstWrite = false;
-      outFile << "% time\tcellId\tIMSI\tframe\tsframe\tRNTI\tmcsTb1\tsizeTb1\tmcsTb2\tsizeTb2\tccId";
-      outFile << std::endl;
-    }
-  else
-    {
-      outFile.open (GetDlOutputFilename ().c_str (),  std::ios_base::app);
-      if (!outFile.is_open ())
-        {
-          NS_LOG_ERROR ("Can't open file " << GetDlOutputFilename ().c_str ());
-          return;
-        }
+      m_dlOutFile << "% time\tcellId\tIMSI\tframe\tsframe\tRNTI\tmcsTb1\tsizeTb1\tmcsTb2\tsizeTb2\tccId";
+      m_dlOutFile << "\n";
     }
 
-  outFile << Simulator::Now ().GetSeconds () << "\t";
-  outFile << (uint32_t) cellId << "\t";
-  outFile << imsi << "\t";
-  outFile << dlSchedulingCallbackInfo.frameNo << "\t";
-  outFile << dlSchedulingCallbackInfo.subframeNo << "\t";
-  outFile << dlSchedulingCallbackInfo.rnti << "\t";
-  outFile << (uint32_t) dlSchedulingCallbackInfo.mcsTb1 << "\t";
-  outFile << dlSchedulingCallbackInfo.sizeTb1 << "\t";
-  outFile << (uint32_t) dlSchedulingCallbackInfo.mcsTb2 << "\t";
-  outFile << dlSchedulingCallbackInfo.sizeTb2 << "\t";
-  outFile << (uint32_t) dlSchedulingCallbackInfo.componentCarrierId << std::endl;
-  outFile.close ();
+  m_dlOutFile << Simulator::Now ().GetSeconds () << "\t";
+  m_dlOutFile << (uint32_t) cellId << "\t";
+  m_dlOutFile << imsi << "\t";
+  m_dlOutFile << dlSchedulingCallbackInfo.frameNo << "\t";
+  m_dlOutFile << dlSchedulingCallbackInfo.subframeNo << "\t";
+  m_dlOutFile << dlSchedulingCallbackInfo.rnti << "\t";
+  m_dlOutFile << (uint32_t) dlSchedulingCallbackInfo.mcsTb1 << "\t";
+  m_dlOutFile << dlSchedulingCallbackInfo.sizeTb1 << "\t";
+  m_dlOutFile << (uint32_t) dlSchedulingCallbackInfo.mcsTb2 << "\t";
+  m_dlOutFile << dlSchedulingCallbackInfo.sizeTb2 << "\t";
+  m_dlOutFile << (uint32_t) dlSchedulingCallbackInfo.componentCarrierId << std::endl;
 }
 
 void
@@ -140,39 +138,28 @@
   NS_LOG_FUNCTION (this << cellId << imsi << frameNo << subframeNo << rnti << (uint32_t) mcsTb << size);
   NS_LOG_INFO ("Write UL Mac Stats in " << GetUlOutputFilename ().c_str ());
 
-  std::ofstream outFile;
   if ( m_ulFirstWrite == true )
     {
-      outFile.open (GetUlOutputFilename ().c_str ());
-      if (!outFile.is_open ())
+      m_ulOutFile.open (GetUlOutputFilename ().c_str ());
+      if (!m_ulOutFile.is_open ())
         {
           NS_LOG_ERROR ("Can't open file " << GetUlOutputFilename ().c_str ());
           return;
         }
       m_ulFirstWrite = false;
-      outFile << "% time\tcellId\tIMSI\tframe\tsframe\tRNTI\tmcs\tsize\tccId";
-      outFile << std::endl;
-    }
-  else
-    {
-      outFile.open (GetUlOutputFilename ().c_str (),  std::ios_base::app);
-      if (!outFile.is_open ())
-        {
-          NS_LOG_ERROR ("Can't open file " << GetUlOutputFilename ().c_str ());
-          return;
-        }
+      m_ulOutFile << "% time\tcellId\tIMSI\tframe\tsframe\tRNTI\tmcs\tsize\tccId";
+      m_ulOutFile << "\n";
     }
 
-  outFile << Simulator::Now ().GetSeconds () << "\t";
-  outFile << (uint32_t) cellId << "\t";
-  outFile << imsi << "\t";
-  outFile << frameNo << "\t";
-  outFile << subframeNo << "\t";
-  outFile << rnti << "\t";
-  outFile << (uint32_t) mcsTb << "\t";
-  outFile << size << "\t";
-  outFile << (uint32_t) componentCarrierId << std::endl;
-  outFile.close ();
+  m_ulOutFile << Simulator::Now ().GetSeconds () << "\t";
+  m_ulOutFile << (uint32_t) cellId << "\t";
+  m_ulOutFile << imsi << "\t";
+  m_ulOutFile << frameNo << "\t";
+  m_ulOutFile << subframeNo << "\t";
+  m_ulOutFile << rnti << "\t";
+  m_ulOutFile << (uint32_t) mcsTb << "\t";
+  m_ulOutFile << size << "\t";
+  m_ulOutFile << (uint32_t) componentCarrierId << std::endl;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/mac-stats-calculator.h ns-3.36/src/lte/helper/mac-stats-calculator.h
--- ns-3.35/src/lte/helper/mac-stats-calculator.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/mac-stats-calculator.h	2022-04-30 18:23:57.922733800 -0700
@@ -166,6 +166,15 @@
    */
   bool m_ulFirstWrite;
 
+  /**
+   * Downlink output trace file
+   */
+  std::ofstream m_dlOutFile;
+
+  /**
+   * Uplink output trace file
+   */
+  std::ofstream m_ulOutFile;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/no-backhaul-epc-helper.cc ns-3.36/src/lte/helper/no-backhaul-epc-helper.cc
--- ns-3.35/src/lte/helper/no-backhaul-epc-helper.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/no-backhaul-epc-helper.cc	2022-04-30 18:23:57.922733800 -0700
@@ -307,9 +307,9 @@
 
 
 void
-NoBackhaulEpcHelper::AddEnb (Ptr<Node> enb, Ptr<NetDevice> lteEnbNetDevice, uint16_t cellId)
+NoBackhaulEpcHelper::AddEnb (Ptr<Node> enb, Ptr<NetDevice> lteEnbNetDevice, std::vector<uint16_t> cellIds)
 {
-  NS_LOG_FUNCTION (this << enb << lteEnbNetDevice << cellId);
+  NS_LOG_FUNCTION (this << enb << lteEnbNetDevice << cellIds.size ());
   NS_ASSERT (enb == lteEnbNetDevice->GetNode ());
 
   int retval;
@@ -347,8 +347,8 @@
   retval = enbLteSocket6->Connect (enbLteSocketConnectAddress6);
   NS_ASSERT (retval == 0);  
 
-  NS_LOG_INFO ("Create EpcEnbApplication");
-  Ptr<EpcEnbApplication> enbApp = CreateObject<EpcEnbApplication> (enbLteSocket, enbLteSocket6, cellId);
+  NS_LOG_INFO ("Create EpcEnbApplication for cell ID " << cellIds.at (0));
+  Ptr<EpcEnbApplication> enbApp = CreateObject<EpcEnbApplication> (enbLteSocket, enbLteSocket6, cellIds.at (0));
   enb->AddApplication (enbApp);
   NS_ASSERT (enb->GetNApplications () == 1);
   NS_ASSERT_MSG (enb->GetApplication (0)->GetObject<EpcEnbApplication> () != 0, "cannot retrieve EpcEnbApplication");
@@ -412,14 +412,17 @@
   NS_ABORT_MSG_IF (enb1LteDevice == nullptr , "Unable to find LteEnbNetDevice for the first eNB");
   NS_ABORT_MSG_IF (enb2LteDevice == nullptr , "Unable to find LteEnbNetDevice for the second eNB");
 
-  uint16_t enb1CellId = enb1LteDevice->GetCellId ();
-  uint16_t enb2CellId = enb2LteDevice->GetCellId ();
+  std::vector<uint16_t> enb1CellIds = enb1LteDevice->GetCellIds ();
+  std::vector<uint16_t> enb2CellIds = enb2LteDevice->GetCellIds ();
+
+  uint16_t enb1CellId = enb1CellIds.at (0);
+  uint16_t enb2CellId = enb2CellIds.at (0);
 
   NS_LOG_LOGIC ("LteEnbNetDevice #1 = " << enb1LteDev << " - CellId = " << enb1CellId);
   NS_LOG_LOGIC ("LteEnbNetDevice #2 = " << enb2LteDev << " - CellId = " << enb2CellId);
 
-  enb1X2->AddX2Interface (enb1CellId, enb1X2Address, enb2CellId, enb2X2Address);
-  enb2X2->AddX2Interface (enb2CellId, enb2X2Address, enb1CellId, enb1X2Address);
+  enb1X2->AddX2Interface (enb1CellId, enb1X2Address, enb2CellIds, enb2X2Address);
+  enb2X2->AddX2Interface (enb2CellId, enb2X2Address, enb1CellIds, enb1X2Address);
 
   enb1LteDevice->GetRrc ()->AddX2Neighbour (enb2CellId);
   enb2LteDevice->GetRrc ()->AddX2Neighbour (enb1CellId);
@@ -542,9 +545,9 @@
 
 
 void
-NoBackhaulEpcHelper::AddS1Interface (Ptr<Node> enb, Ipv4Address enbAddress, Ipv4Address sgwAddress, uint16_t cellId)
+NoBackhaulEpcHelper::AddS1Interface (Ptr<Node> enb, Ipv4Address enbAddress, Ipv4Address sgwAddress, std::vector<uint16_t> cellIds)
 {
-  NS_LOG_FUNCTION (this << enb << enbAddress << sgwAddress << cellId);
+  NS_LOG_FUNCTION (this << enb << enbAddress << sgwAddress << cellIds.size ());
 
   // create S1-U socket for the ENB
   Ptr<Socket> enbS1uSocket = Socket::CreateSocket (enb, TypeId::LookupByName ("ns3::UdpSocketFactory"));
@@ -556,14 +559,12 @@
   enbApp->AddS1Interface (enbS1uSocket, enbAddress, sgwAddress);
 
   NS_LOG_INFO ("Connect S1-AP interface");
-  if (cellId == 0)
+  for (uint16_t cellId : cellIds)
     {
-      Ptr<LteEnbNetDevice> enbLteDev = enb->GetDevice (0)->GetObject<LteEnbNetDevice> ();
-      NS_ASSERT_MSG (enbLteDev, "LteEnbNetDevice is missing");
-      cellId = enbLteDev->GetCellId ();
+      NS_LOG_DEBUG ("Adding MME and SGW for cell ID " << cellId);
+      m_mmeApp->AddEnb (cellId, enbAddress, enbApp->GetS1apSapEnb ());
+      m_sgwApp->AddEnb (cellId, enbAddress, sgwAddress);
     }
-  m_mmeApp->AddEnb (cellId, enbAddress, enbApp->GetS1apSapEnb ());
-  m_sgwApp->AddEnb (cellId, enbAddress, sgwAddress);
   enbApp->SetS1apSapMme (m_mmeApp->GetS1apSapMme ());
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/no-backhaul-epc-helper.h ns-3.36/src/lte/helper/no-backhaul-epc-helper.h
--- ns-3.35/src/lte/helper/no-backhaul-epc-helper.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/no-backhaul-epc-helper.h	2022-04-30 18:23:57.922733800 -0700
@@ -66,10 +66,10 @@
   virtual void DoDispose ();
 
   // inherited from EpcHelper
-  virtual void AddEnb (Ptr<Node> enbNode, Ptr<NetDevice> lteEnbNetDevice, uint16_t cellId);
+  virtual void AddEnb (Ptr<Node> enbNode, Ptr<NetDevice> lteEnbNetDevice, std::vector<uint16_t> cellIds);
   virtual void AddUe (Ptr<NetDevice> ueLteDevice, uint64_t imsi);
   virtual void AddX2Interface (Ptr<Node> enbNode1, Ptr<Node> enbNode2);
-  virtual void AddS1Interface (Ptr<Node> enb, Ipv4Address enbAddress, Ipv4Address sgwAddress, uint16_t cellId = 0);
+  virtual void AddS1Interface (Ptr<Node> enb, Ipv4Address enbAddress, Ipv4Address sgwAddress, std::vector<uint16_t> cellIds);
   virtual uint8_t ActivateEpsBearer (Ptr<NetDevice> ueLteDevice, uint64_t imsi, Ptr<EpcTft> tft, EpsBearer bearer);
   virtual Ptr<Node> GetSgwNode () const;
   virtual Ptr<Node> GetPgwNode () const;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/phy-rx-stats-calculator.cc ns-3.36/src/lte/helper/phy-rx-stats-calculator.cc
--- ns-3.35/src/lte/helper/phy-rx-stats-calculator.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/phy-rx-stats-calculator.cc	2022-04-30 18:23:57.922733800 -0700
@@ -42,6 +42,15 @@
 PhyRxStatsCalculator::~PhyRxStatsCalculator ()
 {
   NS_LOG_FUNCTION (this);
+  if (m_dlRxOutFile.is_open())
+    {
+      m_dlRxOutFile.close();
+    }
+
+  if (m_ulRxOutFile.is_open())
+    {
+      m_ulRxOutFile.close();
+    }
 }
 
 TypeId
@@ -95,42 +104,31 @@
   NS_LOG_FUNCTION (this << params.m_cellId << params.m_imsi << params.m_timestamp << params.m_rnti << params.m_layer << params.m_mcs << params.m_size << params.m_rv << params.m_ndi << params.m_correctness);
   NS_LOG_INFO ("Write DL Rx Phy Stats in " << GetDlRxOutputFilename ().c_str ());
 
-  std::ofstream outFile;
   if ( m_dlRxFirstWrite == true )
     {
-      outFile.open (GetDlRxOutputFilename ().c_str ());
-      if (!outFile.is_open ())
+      m_dlRxOutFile.open (GetDlRxOutputFilename ().c_str ());
+      if (!m_dlRxOutFile.is_open ())
         {
           NS_LOG_ERROR ("Can't open file " << GetDlRxOutputFilename ().c_str ());
           return;
         }
       m_dlRxFirstWrite = false;
-      outFile << "% time\tcellId\tIMSI\tRNTI\ttxMode\tlayer\tmcs\tsize\trv\tndi\tcorrect\tccId";
-      outFile << std::endl;
-    }
-  else
-    {
-      outFile.open (GetDlRxOutputFilename ().c_str (),  std::ios_base::app);
-      if (!outFile.is_open ())
-        {
-          NS_LOG_ERROR ("Can't open file " << GetDlRxOutputFilename ().c_str ());
-          return;
-        }
+      m_dlRxOutFile << "% time\tcellId\tIMSI\tRNTI\ttxMode\tlayer\tmcs\tsize\trv\tndi\tcorrect\tccId";
+      m_dlRxOutFile << "\n";
     }
 
-  outFile << params.m_timestamp << "\t";
-  outFile << (uint32_t) params.m_cellId << "\t";
-  outFile << params.m_imsi << "\t";
-  outFile << params.m_rnti << "\t";
-  outFile << (uint32_t) params.m_txMode << "\t";
-  outFile << (uint32_t) params.m_layer << "\t";
-  outFile << (uint32_t) params.m_mcs << "\t";
-  outFile << params.m_size << "\t";
-  outFile << (uint32_t) params.m_rv << "\t";
-  outFile << (uint32_t) params.m_ndi << "\t";
-  outFile << (uint32_t) params.m_correctness << "\t";
-  outFile << (uint32_t) params.m_ccId << std::endl;
-  outFile.close ();
+  m_dlRxOutFile << params.m_timestamp << "\t";
+  m_dlRxOutFile << (uint32_t) params.m_cellId << "\t";
+  m_dlRxOutFile << params.m_imsi << "\t";
+  m_dlRxOutFile << params.m_rnti << "\t";
+  m_dlRxOutFile << (uint32_t) params.m_txMode << "\t";
+  m_dlRxOutFile << (uint32_t) params.m_layer << "\t";
+  m_dlRxOutFile << (uint32_t) params.m_mcs << "\t";
+  m_dlRxOutFile << params.m_size << "\t";
+  m_dlRxOutFile << (uint32_t) params.m_rv << "\t";
+  m_dlRxOutFile << (uint32_t) params.m_ndi << "\t";
+  m_dlRxOutFile << (uint32_t) params.m_correctness << "\t";
+  m_dlRxOutFile << (uint32_t) params.m_ccId << std::endl;
 }
 
 void
@@ -139,41 +137,30 @@
   NS_LOG_FUNCTION (this << params.m_cellId << params.m_imsi << params.m_timestamp << params.m_rnti << params.m_layer << params.m_mcs << params.m_size << params.m_rv << params.m_ndi << params.m_correctness);
   NS_LOG_INFO ("Write UL Rx Phy Stats in " << GetUlRxOutputFilename ().c_str ());
 
-  std::ofstream outFile;
   if ( m_ulRxFirstWrite == true )
     {
-      outFile.open (GetUlRxOutputFilename ().c_str ());
-      if (!outFile.is_open ())
+      m_ulRxOutFile.open (GetUlRxOutputFilename ().c_str ());
+      if (!m_ulRxOutFile.is_open ())
         {
           NS_LOG_ERROR ("Can't open file " << GetUlRxOutputFilename ().c_str ());
           return;
         }
       m_ulRxFirstWrite = false;
-      outFile << "% time\tcellId\tIMSI\tRNTI\tlayer\tmcs\tsize\trv\tndi\tcorrect\tccId";
-      outFile << std::endl;
-    }
-  else
-    {
-      outFile.open (GetUlRxOutputFilename ().c_str (),  std::ios_base::app);
-      if (!outFile.is_open ())
-        {
-          NS_LOG_ERROR ("Can't open file " << GetUlRxOutputFilename ().c_str ());
-          return;
-        }
+      m_ulRxOutFile << "% time\tcellId\tIMSI\tRNTI\tlayer\tmcs\tsize\trv\tndi\tcorrect\tccId";
+      m_ulRxOutFile << "\n";
     }
 
-  outFile << params.m_timestamp << "\t";
-  outFile << (uint32_t) params.m_cellId << "\t";
-  outFile << params.m_imsi << "\t";
-  outFile << params.m_rnti << "\t";
-  outFile << (uint32_t) params.m_layer << "\t";
-  outFile << (uint32_t) params.m_mcs << "\t";
-  outFile << params.m_size << "\t";
-  outFile << (uint32_t) params.m_rv << "\t";
-  outFile << (uint32_t) params.m_ndi << "\t";
-  outFile << (uint32_t) params.m_correctness << "\t";
-  outFile << (uint32_t) params.m_ccId << std::endl;
-  outFile.close ();
+  m_ulRxOutFile << params.m_timestamp << "\t";
+  m_ulRxOutFile << (uint32_t) params.m_cellId << "\t";
+  m_ulRxOutFile << params.m_imsi << "\t";
+  m_ulRxOutFile << params.m_rnti << "\t";
+  m_ulRxOutFile << (uint32_t) params.m_layer << "\t";
+  m_ulRxOutFile << (uint32_t) params.m_mcs << "\t";
+  m_ulRxOutFile << params.m_size << "\t";
+  m_ulRxOutFile << (uint32_t) params.m_rv << "\t";
+  m_ulRxOutFile << (uint32_t) params.m_ndi << "\t";
+  m_ulRxOutFile << (uint32_t) params.m_correctness << "\t";
+  m_ulRxOutFile << (uint32_t) params.m_ccId << std::endl;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/phy-rx-stats-calculator.h ns-3.36/src/lte/helper/phy-rx-stats-calculator.h
--- ns-3.35/src/lte/helper/phy-rx-stats-calculator.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/phy-rx-stats-calculator.h	2022-04-30 18:23:57.922733800 -0700
@@ -142,6 +142,15 @@
    */
   bool m_ulRxFirstWrite;
 
+  /**
+   * DL RX PHY output trace file
+   */
+  std::ofstream m_dlRxOutFile;
+
+  /**
+   * UL RX PHY output trace file
+   */
+  std::ofstream m_ulRxOutFile;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/phy-stats-calculator.cc ns-3.36/src/lte/helper/phy-stats-calculator.cc
--- ns-3.35/src/lte/helper/phy-stats-calculator.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/phy-stats-calculator.cc	2022-04-30 18:23:57.922733800 -0700
@@ -42,6 +42,20 @@
 PhyStatsCalculator::~PhyStatsCalculator ()
 {
   NS_LOG_FUNCTION (this);
+  if (m_interferenceOutFile.is_open())
+    {
+      m_interferenceOutFile.close();
+    }
+
+  if (m_rsrpOutFile.is_open())
+    {
+      m_rsrpOutFile.close();
+    }
+
+  if (m_ueSinrOutFile.is_open())
+    {
+      m_ueSinrOutFile.close();
+    }
 }
 
 TypeId
@@ -115,37 +129,26 @@
   NS_LOG_FUNCTION (this << cellId <<  imsi << rnti  << rsrp << sinr);
   NS_LOG_INFO ("Write RSRP/SINR Phy Stats in " << GetCurrentCellRsrpSinrFilename ().c_str ());
 
-  std::ofstream outFile;
   if ( m_RsrpSinrFirstWrite == true )
     {
-      outFile.open (GetCurrentCellRsrpSinrFilename ().c_str ());
-      if (!outFile.is_open ())
+      m_rsrpOutFile.open (GetCurrentCellRsrpSinrFilename ().c_str ());
+      if (!m_rsrpOutFile.is_open ())
         {
           NS_LOG_ERROR ("Can't open file " << GetCurrentCellRsrpSinrFilename ().c_str ());
           return;
         }
       m_RsrpSinrFirstWrite = false;
-      outFile << "% time\tcellId\tIMSI\tRNTI\trsrp\tsinr\tComponentCarrierId";
-      outFile << std::endl;
-    }
-  else
-    {
-      outFile.open (GetCurrentCellRsrpSinrFilename ().c_str (),  std::ios_base::app);
-      if (!outFile.is_open ())
-        {
-          NS_LOG_ERROR ("Can't open file " << GetCurrentCellRsrpSinrFilename ().c_str ());
-          return;
-        }
+      m_rsrpOutFile << "% time\tcellId\tIMSI\tRNTI\trsrp\tsinr\tComponentCarrierId";
+      m_rsrpOutFile << "\n";
     }
 
-  outFile << Simulator::Now ().GetSeconds () << "\t";
-  outFile << cellId << "\t";
-  outFile << imsi << "\t";
-  outFile << rnti << "\t";
-  outFile << rsrp << "\t";
-  outFile << sinr << "\t";
-  outFile << (uint32_t)componentCarrierId << std::endl;
-  outFile.close ();
+  m_rsrpOutFile << Simulator::Now ().GetSeconds () << "\t";
+  m_rsrpOutFile << cellId << "\t";
+  m_rsrpOutFile << imsi << "\t";
+  m_rsrpOutFile << rnti << "\t";
+  m_rsrpOutFile << rsrp << "\t";
+  m_rsrpOutFile << sinr << "\t";
+  m_rsrpOutFile << (uint32_t)componentCarrierId << std::endl;
 }
 
 void
@@ -154,36 +157,24 @@
   NS_LOG_FUNCTION (this << cellId <<  imsi << rnti  << sinrLinear);
   NS_LOG_INFO ("Write SINR Linear Phy Stats in " << GetUeSinrFilename ().c_str ());
 
-  std::ofstream outFile;
   if ( m_UeSinrFirstWrite == true )
     {
-      outFile.open (GetUeSinrFilename ().c_str ());
-      if (!outFile.is_open ())
+      m_ueSinrOutFile.open (GetUeSinrFilename ().c_str ());
+      if (!m_ueSinrOutFile.is_open ())
         {
           NS_LOG_ERROR ("Can't open file " << GetUeSinrFilename ().c_str ());
           return;
         }
       m_UeSinrFirstWrite = false;
-      outFile << "% time\tcellId\tIMSI\tRNTI\tsinrLinear\tcomponentCarrierId";
-      outFile << std::endl;
+      m_ueSinrOutFile << "% time\tcellId\tIMSI\tRNTI\tsinrLinear\tcomponentCarrierId";
+      m_ueSinrOutFile << "\n";
     }
-  else
-    {
-      outFile.open (GetUeSinrFilename ().c_str (),  std::ios_base::app);
-      if (!outFile.is_open ())
-        {
-          NS_LOG_ERROR ("Can't open file " << GetUeSinrFilename ().c_str ());
-          return;
-        }
-    }
-
-  outFile << Simulator::Now ().GetSeconds () << "\t";
-  outFile << cellId << "\t";
-  outFile << imsi << "\t";
-  outFile << rnti << "\t";
-  outFile << sinrLinear << "\t";
-  outFile << (uint32_t)componentCarrierId << std::endl;
-  outFile.close ();
+  m_ueSinrOutFile << Simulator::Now ().GetSeconds () << "\t";
+  m_ueSinrOutFile << cellId << "\t";
+  m_ueSinrOutFile << imsi << "\t";
+  m_ueSinrOutFile << rnti << "\t";
+  m_ueSinrOutFile << sinrLinear << "\t";
+  m_ueSinrOutFile << (uint32_t)componentCarrierId << std::endl;
 }
 
 void
@@ -192,33 +183,22 @@
   NS_LOG_FUNCTION (this << cellId <<  interference);
   NS_LOG_INFO ("Write Interference Phy Stats in " << GetInterferenceFilename ().c_str ());
 
-  std::ofstream outFile;
   if ( m_InterferenceFirstWrite == true )
     {
-      outFile.open (GetInterferenceFilename ().c_str ());
-      if (!outFile.is_open ())
+      m_interferenceOutFile.open (GetInterferenceFilename ().c_str ());
+      if (!m_interferenceOutFile.is_open ())
         {
           NS_LOG_ERROR ("Can't open file " << GetInterferenceFilename ().c_str ());
           return;
         }
       m_InterferenceFirstWrite = false;
-      outFile << "% time\tcellId\tInterference";
-      outFile << std::endl;
-    }
-  else
-    {
-      outFile.open (GetInterferenceFilename ().c_str (),  std::ios_base::app);
-      if (!outFile.is_open ())
-        {
-          NS_LOG_ERROR ("Can't open file " << GetInterferenceFilename ().c_str ());
-          return;
-        }
+      m_interferenceOutFile << "% time\tcellId\tInterference";
+      m_interferenceOutFile << "\n";
     }
 
-  outFile << Simulator::Now ().GetSeconds () << "\t";
-  outFile << cellId << "\t";
-  outFile << *interference;
-  outFile.close ();
+  m_interferenceOutFile << Simulator::Now ().GetSeconds () << "\t";
+  m_interferenceOutFile << cellId << "\t";
+  m_interferenceOutFile << *interference;
 }
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/phy-stats-calculator.h ns-3.36/src/lte/helper/phy-stats-calculator.h
--- ns-3.35/src/lte/helper/phy-stats-calculator.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/phy-stats-calculator.h	2022-04-30 18:23:57.922733800 -0700
@@ -221,6 +221,20 @@
    */
   std::string m_interferenceFilename;
 
+  /**
+   * RSRP statistics output trace file
+   */
+  std::ofstream m_rsrpOutFile;
+
+  /**
+   * UE SINR statistics output trace file
+   */
+  std::ofstream m_ueSinrOutFile;
+
+  /**
+   * Interference statistics output trace file
+   */
+  std::ofstream m_interferenceOutFile;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/phy-tx-stats-calculator.cc ns-3.36/src/lte/helper/phy-tx-stats-calculator.cc
--- ns-3.35/src/lte/helper/phy-tx-stats-calculator.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/phy-tx-stats-calculator.cc	2022-04-30 18:23:57.922733800 -0700
@@ -42,8 +42,16 @@
 PhyTxStatsCalculator::~PhyTxStatsCalculator ()
 {
   NS_LOG_FUNCTION (this);
-}
+  if (m_dlTxOutFile.is_open())
+    {
+      m_dlTxOutFile.close();
+    }
 
+  if (m_ulTxOutFile.is_open())
+    {
+      m_ulTxOutFile.close();
+    }
+}
 TypeId
 PhyTxStatsCalculator::GetTypeId (void)
 {
@@ -95,41 +103,30 @@
   NS_LOG_FUNCTION (this << params.m_cellId << params.m_imsi << params.m_timestamp << params.m_rnti << params.m_layer << params.m_mcs << params.m_size << params.m_rv << params.m_ndi);
   NS_LOG_INFO ("Write DL Tx Phy Stats in " << GetDlTxOutputFilename ().c_str ());
 
-  std::ofstream outFile;
   if ( m_dlTxFirstWrite == true )
     {
-      outFile.open (GetDlOutputFilename ().c_str ());
-      if (!outFile.is_open ())
+      m_dlTxOutFile.open (GetDlOutputFilename ().c_str ());
+      if (!m_dlTxOutFile.is_open ())
         {
           NS_LOG_ERROR ("Can't open file " << GetDlTxOutputFilename ().c_str ());
           return;
         }
       m_dlTxFirstWrite = false;
-      outFile << "% time\tcellId\tIMSI\tRNTI\tlayer\tmcs\tsize\trv\tndi\tccId";
-      outFile << std::endl;
-    }
-  else
-    {
-      outFile.open (GetDlTxOutputFilename ().c_str (),  std::ios_base::app);
-      if (!outFile.is_open ())
-        {
-          NS_LOG_ERROR ("Can't open file " << GetDlTxOutputFilename ().c_str ());
-          return;
-        }
+      m_dlTxOutFile << "% time\tcellId\tIMSI\tRNTI\tlayer\tmcs\tsize\trv\tndi\tccId";
+      m_dlTxOutFile << "\n";
     }
 
-  outFile << params.m_timestamp << "\t";
-  outFile << (uint32_t) params.m_cellId << "\t";
-  outFile << params.m_imsi << "\t";
-  outFile << params.m_rnti << "\t";
-  //outFile << (uint32_t) params.m_txMode << "\t"; // txMode is not available at dl tx side
-  outFile << (uint32_t) params.m_layer << "\t";
-  outFile << (uint32_t) params.m_mcs << "\t";
-  outFile << params.m_size << "\t";
-  outFile << (uint32_t) params.m_rv << "\t";
-  outFile << (uint32_t) params.m_ndi << "\t";
-  outFile << (uint32_t) params.m_ccId << std::endl;
-  outFile.close ();
+  m_dlTxOutFile << params.m_timestamp << "\t";
+  m_dlTxOutFile << (uint32_t) params.m_cellId << "\t";
+  m_dlTxOutFile << params.m_imsi << "\t";
+  m_dlTxOutFile << params.m_rnti << "\t";
+  //m_dlTxOutFile << (uint32_t) params.m_txMode << "\t"; // txMode is not available at dl tx side
+  m_dlTxOutFile << (uint32_t) params.m_layer << "\t";
+  m_dlTxOutFile << (uint32_t) params.m_mcs << "\t";
+  m_dlTxOutFile << params.m_size << "\t";
+  m_dlTxOutFile << (uint32_t) params.m_rv << "\t";
+  m_dlTxOutFile << (uint32_t) params.m_ndi << "\t";
+  m_dlTxOutFile << (uint32_t) params.m_ccId << std::endl;
 }
 
 void
@@ -138,42 +135,31 @@
   NS_LOG_FUNCTION (this << params.m_cellId << params.m_imsi << params.m_timestamp << params.m_rnti << params.m_layer << params.m_mcs << params.m_size << params.m_rv << params.m_ndi);
   NS_LOG_INFO ("Write UL Tx Phy Stats in " << GetUlTxOutputFilename ().c_str ());
 
-  std::ofstream outFile;
   if ( m_ulTxFirstWrite == true )
     {
-      outFile.open (GetUlTxOutputFilename ().c_str ());
-      if (!outFile.is_open ())
+      m_ulTxOutFile.open (GetUlTxOutputFilename ().c_str ());
+      if (!m_ulTxOutFile.is_open ())
         {
           NS_LOG_ERROR ("Can't open file " << GetUlTxOutputFilename ().c_str ());
           return;
         }
       m_ulTxFirstWrite = false;
-//       outFile << "% time\tcellId\tIMSI\tRNTI\ttxMode\tlayer\tmcs\tsize\trv\tndi";
-      outFile << "% time\tcellId\tIMSI\tRNTI\tlayer\tmcs\tsize\trv\tndi\tccId";
-      outFile << std::endl;
-    }
-  else
-    {
-      outFile.open (GetUlTxOutputFilename ().c_str (),  std::ios_base::app);
-      if (!outFile.is_open ())
-        {
-          NS_LOG_ERROR ("Can't open file " << GetUlTxOutputFilename ().c_str ());
-          return;
-        }
+      //m_ulTxOutFile << "% time\tcellId\tIMSI\tRNTI\ttxMode\tlayer\tmcs\tsize\trv\tndi";
+      m_ulTxOutFile << "% time\tcellId\tIMSI\tRNTI\tlayer\tmcs\tsize\trv\tndi\tccId";
+      m_ulTxOutFile << "\n";
     }
 
-  outFile << params.m_timestamp << "\t";
-  outFile << (uint32_t) params.m_cellId << "\t";
-  outFile << params.m_imsi << "\t";
-  outFile << params.m_rnti << "\t";
-  //outFile << (uint32_t) params.m_txMode << "\t";
-  outFile << (uint32_t) params.m_layer << "\t";
-  outFile << (uint32_t) params.m_mcs << "\t";
-  outFile << params.m_size << "\t";
-  outFile << (uint32_t) params.m_rv << "\t";
-  outFile << (uint32_t) params.m_ndi << "\t";
-  outFile << (uint32_t) params.m_ccId << std::endl;
-  outFile.close ();
+  m_ulTxOutFile << params.m_timestamp << "\t";
+  m_ulTxOutFile << (uint32_t) params.m_cellId << "\t";
+  m_ulTxOutFile << params.m_imsi << "\t";
+  m_ulTxOutFile << params.m_rnti << "\t";
+  //m_ulTxOutFile << (uint32_t) params.m_txMode << "\t";
+  m_ulTxOutFile << (uint32_t) params.m_layer << "\t";
+  m_ulTxOutFile << (uint32_t) params.m_mcs << "\t";
+  m_ulTxOutFile << params.m_size << "\t";
+  m_ulTxOutFile << (uint32_t) params.m_rv << "\t";
+  m_ulTxOutFile << (uint32_t) params.m_ndi << "\t";
+  m_ulTxOutFile << (uint32_t) params.m_ccId << std::endl;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/phy-tx-stats-calculator.h ns-3.36/src/lte/helper/phy-tx-stats-calculator.h
--- ns-3.35/src/lte/helper/phy-tx-stats-calculator.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/phy-tx-stats-calculator.h	2022-04-30 18:23:57.922733800 -0700
@@ -143,6 +143,15 @@
    */
   bool m_ulTxFirstWrite;
 
+  /**
+   * DL TX PHY statistics output trace file
+   */
+  std::ofstream m_dlTxOutFile;
+
+  /**
+   * UL TX PHY statistics output trace file
+   */
+  std::ofstream m_ulTxOutFile;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/point-to-point-epc-helper.cc ns-3.36/src/lte/helper/point-to-point-epc-helper.cc
--- ns-3.35/src/lte/helper/point-to-point-epc-helper.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/point-to-point-epc-helper.cc	2022-04-30 18:23:57.922733800 -0700
@@ -106,11 +106,11 @@
 
 
 void
-PointToPointEpcHelper::AddEnb (Ptr<Node> enb, Ptr<NetDevice> lteEnbNetDevice, uint16_t cellId)
+PointToPointEpcHelper::AddEnb (Ptr<Node> enb, Ptr<NetDevice> lteEnbNetDevice, std::vector<uint16_t> cellIds)
 {
-  NS_LOG_FUNCTION (this << enb << lteEnbNetDevice << cellId);
+  NS_LOG_FUNCTION (this << enb << lteEnbNetDevice << cellIds.size ());
 
-  NoBackhaulEpcHelper::AddEnb (enb, lteEnbNetDevice, cellId);
+  NoBackhaulEpcHelper::AddEnb (enb, lteEnbNetDevice, cellIds);
 
   // create a point to point link between the eNB and the SGW with
   // the corresponding new NetDevices on each side
@@ -135,7 +135,7 @@
   Ipv4Address enbS1uAddress = enbSgwIpIfaces.GetAddress (0);
   Ipv4Address sgwS1uAddress = enbSgwIpIfaces.GetAddress (1);
 
-  NoBackhaulEpcHelper::AddS1Interface (enb, enbS1uAddress, sgwS1uAddress, cellId);
+  NoBackhaulEpcHelper::AddS1Interface (enb, enbS1uAddress, sgwS1uAddress, cellIds);
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/helper/point-to-point-epc-helper.h ns-3.36/src/lte/helper/point-to-point-epc-helper.h
--- ns-3.35/src/lte/helper/point-to-point-epc-helper.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/helper/point-to-point-epc-helper.h	2022-04-30 18:23:57.922733800 -0700
@@ -58,8 +58,7 @@
   virtual void DoDispose ();
 
   // inherited from EpcHelper
-  virtual void AddEnb (Ptr<Node> enbNode, Ptr<NetDevice> lteEnbNetDevice, uint16_t cellId);
-
+  virtual void AddEnb (Ptr<Node> enbNode, Ptr<NetDevice> lteEnbNetDevice, std::vector<uint16_t> cellIds);
 
 private:
 
